Attribute VB_Name = "KeyPad"
Option Explicit

Public Declare Function SetWindowPos _
        Lib "user32" ( _
        ByVal hwnd As Long, _
        ByVal hWndInsertAfter As Long, _
        ByVal X As Long, _
        ByVal Y As Long, _
        ByVal cx As Long, _
        ByVal cy As Long, _
        ByVal wFlags As Long) As Long
    Public Const HWND_TOPMOST = -1
    Public Const HWND_TOP = 0
    Public Const HWND_NOTOPMOST = -2
    Public Const HWND_DESKTOP = 0
    Public Const HWND_BOTTOM = 1
    Public Const SWP_NOACTIVATE = &H10
    Public Const SWP_NOMOVE = &H2
    Public Const SWP_NOSIZE = &H1
    

Public Declare Function GetCursorPos Lib "user32" (lpPoint As _
   POINTAPI) As Long

'mouse pointe type
Public Type POINTAPI
        X As Long
        Y As Long
End Type
Public a As POINTAPI

Public Declare Function GetAsyncKeyState _
        Lib "user32.dll" ( _
        ByVal vKey As Long) As Integer
        
Public Declare Sub keybd_event Lib "user32" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)
        Public Const KEYEVENTF_EXTENDEDKEY = &H1
        Public Const KEYEVENTF_KEYUP = &H2
    
Public Declare Function GetForegroundWindow Lib "user32" () As Long
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function SetActiveWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function SetFocus Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function EnableWindow Lib "user32" (ByVal hwnd As Long, ByVal fEnable As Long) As Long
Public Declare Function LockSetForegroundWindow Lib "user32" (ByVal uLockCode As Integer) As Boolean

'foreground window handle
Public FGWin As Long

'screen size
Public ScreenSize As RECT2

'colors and transparency
Public keyBGDcolor As Long
Public keyFGDcolor As Long
Public keyFGDPressedcolor As Long
Public NormalTrans As Integer
Public GhostTrans As Integer
Public AutoTrans As Integer

Public KeyPressed As Boolean

'Special keys pressing
Public AltPressed As Integer
Public CtrlPressed As Integer
Public ShiftPressed As Integer
Public ExtShiftPressed As Integer
Public CapsPressed As Integer
Public WinPressed As Integer

'SymPad or KeyPad
Public SymMode As Boolean

'Ghost mode and hiding
Public GhostMode As Boolean
Public AutoHide As Boolean
Public keyPadHid As Boolean
Public SymPadHid As Boolean
Public AllHid As Boolean
Public AutoHideTime As Integer
Public AutoHideMode As Integer
Public TimeSincePress As Integer

'resolution
Public oldPixelWidth As Integer
Public oldPixelHeight As Integer

'comment in settings file
Private commentText As String

'current key pressed
Public tmpCB As CommandButton

Public lblPadRowNum As Integer
Public lblPadColNum As Integer
Public inLbl(0 To 26, 0 To 150) As Boolean

Public CurX As Integer
Public CurY As Integer

Public PrevKey As String

Public Sub KPsendKeys(inString As String)
Dim Outstr As String, tmpLong As Long, i As Integer

On Error Resume Next

        If GetForegroundWindow = frmNumPad.hwnd Or GetForegroundWindow = FrmkeyPad.hwnd Or GetForegroundWindow = frmSymPad.hwnd Then
            Exit Sub
        End If
        
        PrevKey = inString

        'temporary fix for keys
        'eventually all keys should use keybd_event instead of sendkeys
            Select Case LCase(inString)
                Case 0
                 tmpLong = &H30
                '0 key
                
                Case 1
                 tmpLong = &H31
                '1 key
                
                Case 2
                 tmpLong = &H32
                '2 key
                
                Case 3
                 tmpLong = &H33
                '3 key
                
                Case 4
                 tmpLong = &H34
                '4 key
                
                Case 5
                 tmpLong = &H35
                '5 key
                
                Case 6
                 tmpLong = &H36
                '6 key
                
                Case 7
                 tmpLong = &H37
                '7 key
                
                Case 8
                 tmpLong = &H38
                '8 key
                
                Case 9
                 tmpLong = &H39
                '9 key
                
                Case "a"
                 tmpLong = &H41
                'A key
                
                Case "b"
                 tmpLong = &H42
                'B key
                
                Case "c"
                 tmpLong = &H43
                'C key
                
                Case "d"
                 tmpLong = &H44
                'D key
                
                Case "e"
                 tmpLong = &H45
                'E key
                
                Case "f"
                 tmpLong = &H46
                'F key
                
                Case "g"
                 tmpLong = &H47
                'G key
                
                Case "h"
                 tmpLong = &H48
                'H key
                
                Case "i"
                 tmpLong = &H49
                'I key
                
                Case "j"
                 tmpLong = &H4A
                'J key
                
                Case "k"
                 tmpLong = &H4B
                'K key
                
                Case "l"
                 tmpLong = &H4C
                'L key
                
                Case "m"
                 tmpLong = &H4D
                'M key
                
                Case "n"
                 tmpLong = &H4E
                'N key
                
                Case "o"
                 tmpLong = &H4F
                'O key
                
                Case "p"
                 tmpLong = &H50
                'P key
                
                Case "q"
                 tmpLong = &H51
                'Q key
                
                Case "r"
                 tmpLong = &H52
                'R key
                
                Case "s"
                 tmpLong = &H53
                'S key
                
                Case "t"
                 tmpLong = &H54
                'T key
                
                Case "u"
                 tmpLong = &H55
                'U key
                
                Case "v"
                 tmpLong = &H56
                'V key
                
                Case "w"
                 tmpLong = &H57
                'W key
                
                Case "x"
                 tmpLong = &H58
                'X key
                
                Case "y"
                 tmpLong = &H59
                'Y key
                
                Case "z"
                 tmpLong = &H5A
                'Z key
                
                'Case "-"
                'tmpLong = &H6D
                'Subtract Key
                
                'Case ","
                'tmpLong = &HBC
                'Windows 2000/XP: For any country/region, the ',' key
                
                'Case "-"
                'Case "tmplong= &HBD"
                'Windows 2000/XP: For any country/region, the '-' key
                
                'Case "."
                'Case "tmplong= &HBE"
                'Windows 2000/XP: For any country/region, the '.' key
                
                'Case "."
                'tmpLong = &H6E
                'Decimal key
                
                'Case "/"
                'tmpLong = &H6F
                'Divide key
                
                
                Case "tab"
                tmpLong = &H9
                'TAB key
                
                Case "clear"
                tmpLong = &HC
                'CLEAR key
                
                Case "enter"
                tmpLong = &HD
                'ENTER key
                                
                Case " "
                tmpLong = &H20
                
                Case "del"
                tmpLong = &H2E
                
                Case "bksp"
                'backspace
                tmpLong = &H8
                
                Case Else
                    
                    i = 0
                    Do While KeyPressed = True
                        
                        Outstr = "{" & inString & "}"
                        'Debug.Print Outstr
                        
                        SendKeys Outstr
                        
                        If KeyPressed = True Then
                            If i > 1 Then
                                Pause 0.02
                            Else
                                Pause 0.2
                            End If
                            i = i + 1
                        End If
                    
                    Loop
                    
                    Exit Sub
                                
            End Select
            
    i = 0
    Do While KeyPressed = True
        
            keybd_event tmpLong, vbNull, &H0, vbNull
            keybd_event tmpLong, vbNull, KEYEVENTF_KEYUP, vbNull
            
                    If KeyPressed = True Then
                        If i > 1 Then
                            Pause 0.02
                        Else
                            Pause 0.2
                        End If
                        i = i + 1
                    End If
            
    Loop
        
End Sub

Public Sub mousePos()
Dim ret As Integer
    ret = GetCursorPos(a)
End Sub

Public Sub reposGhostKey()
    frmGhostButton.cmdEX(0).Width = FrmkeyPad.cmdEX(1).Width
    frmGhostButton.cmdEX(0).Height = FrmkeyPad.cmdEX(1).Height
    frmGhostButton.Width = frmGhostButton.cmdEX(0).Width
    frmGhostButton.Height = frmGhostButton.cmdEX(0).Height
    frmGhostButton.Top = FrmkeyPad.Top + FrmkeyPad.cmdEX(1).Top + 300
    frmGhostButton.Left = FrmkeyPad.Left + FrmkeyPad.cmdEX(1).Left + 40
End Sub

Public Sub restoreBGDcolor(Optional restoreAll As Boolean = True)
Dim i As Integer

    If restoreAll Then
        For i = 1 To frmNumPad.cmdKey.Count
                frmNumPad.cmdKey(i).BackColor = keyBGDcolor
        Next
        If SymMode = True Then
            For i = 0 To frmSymPad.cmdKey.Count - 1
                    frmSymPad.cmdKey(i).BackColor = keyBGDcolor
            Next
        Else
            For i = 0 To FrmkeyPad.cmdKey.Count - 1
                     FrmkeyPad.cmdKey(i).BackColor = keyBGDcolor
            Next
        End If
    Else
        tmpCB.BackColor = keyBGDcolor
    End If
End Sub

Public Sub setTranslucentAll(Optional inVal As Integer = 255, Optional inColor As Long = vbBlue, Optional noGB As Boolean = True)
        
        SetTranslucent FrmkeyPad.hwnd, inColor, inVal, LWA_ALPHA
        SetTranslucent frmNumPad.hwnd, inColor, inVal, LWA_ALPHA
        SetTranslucent frmSymPad.hwnd, inColor, inVal, LWA_ALPHA
        If Not noGB Then
            SetTranslucent frmGhostButton.hwnd, inColor, inVal, LWA_ALPHA
        End If

End Sub



'new detection script in production
Public Sub detectKey2(Optional inPadType As Integer = 0, Optional ByVal inX As Integer = -1, Optional ByVal inY As Integer = -1, Optional inTwips As Integer = 0, Optional x0 As Integer = 0, Optional y0 As Integer = 0, Optional Index As Integer = 0)
Dim i As Integer
Dim KeyGot As Boolean
       
'InPadType
'   all = 0
'   NumPad = 1
'   KeyPad = 2
'   SymPad = 3
'   GhostButton = 4
        
        If AutoHide = True Then
            Exit Sub
        End If
        
      
        'no keys captured yet
        KeyGot = False
        tmpCB.BackColor = keyBGDcolor
        
        If inX = -1 And inY = -1 Then
        'get mouse position for determining which virtual key being pressed
            mousePos
            inX = a.X
            inY = a.Y
            inTwips = 1
        End If
                
        'scale to twips if necessary
        inX = inX * ((1 - inTwips) + inTwips * Screen.TwipsPerPixelX) + x0
        inY = inY * ((1 - inTwips) + inTwips * Screen.TwipsPerPixelY) + y0
        
        CurX = inX
        CurY = inY

      
        '*********************Key Detection Code**************************************


            TimeSincePress = 0
                        
          
            'minimize and exit buttons in dev.
            If inPadType = -5 Then
            'If KeyGot = False And (inPadType = 1 Or inPadType = 0) Then
                For i = 0 To frmNumPad.cmdEX.Count - 1
                    If inX >= (frmNumPad.Left + frmNumPad.cmdEX(i).Left) And _
                        inX <= (frmNumPad.Left + frmNumPad.cmdEX(i).Left + frmNumPad.cmdEX(i).Width) And _
                        inY >= (frmNumPad.Top + frmNumPad.cmdEX(i).Top + 300) And _
                        inY <= (frmNumPad.Top + frmNumPad.cmdEX(i).Top + frmNumPad.cmdEX(i).Height + 300) Then

                            If i = 0 Then
                                Unload frmNumPad
                            ElseIf i = 1 Then

                                If frmNumPad.Width < frmNumPad.cmdEX(0).Width * 3 Then

                                    hidePads False
                                Else
                                    hidePads True
                                End If
                        
                            Else
                                SymMode = Not SymMode
                                showKeyPad
                            End If
                            
                            SetForegroundWindow FGWin
                            SetActiveWindow FGWin
                
                            Set tmpCB = frmNumPad.cmdEX(i)
                            KeyGot = True
                            Exit For
                    End If
                Next
            End If
            
            'KeyPad min button and ghost button
            If KeyGot = False And SymMode = False And (inPadType = 2 Or inPadType = 0) Then
                For i = 0 To FrmkeyPad.cmdEX.Count - 1
                    If inX >= (FrmkeyPad.cmdEX(i).Left) And _
                        inX <= (FrmkeyPad.cmdEX(i).Left + FrmkeyPad.cmdEX(i).Width) And _
                        inY >= (FrmkeyPad.cmdEX(i).Top) And _
                        inY <= (FrmkeyPad.cmdEX(i).Top + FrmkeyPad.cmdEX(i).Height) Then
            
                            Select Case i
                                Case 0
                                    'hide keypad?
                                        keyPadHid = Not keyPadHid
                                        If Not keyPadHid Then
                                            FrmkeyPad.Width = 11625
                                            FrmkeyPad.Height = 3675
                                            
                                        Else
                                            FrmkeyPad.Width = 255
                                            FrmkeyPad.Height = frmNumPad.cmdEX(0).Height + 700
                                        End If
                                
                                Case 1
                                'ghostmode
                                       GhostMode = Not GhostMode
                                       toGhost GhostMode
                                
                                Case 2
                                'translucent up
                                If GhostMode Then
                                    If GhostTrans <= (255 - 20) Then
                                        GhostTrans = GhostTrans + 20
                                    End If
                                    setTranslucentAll GhostTrans
                                Else
                                    If NormalTrans <= (255 - 20) Then
                                        NormalTrans = NormalTrans + 20
                                    End If
                                    setTranslucentAll NormalTrans
                                End If
                                
                                Case 3
                                'translucent down
                                If GhostMode Then
                                    If GhostTrans >= 21 Then
                                        GhostTrans = GhostTrans - 20
                                    End If
                                    setTranslucentAll GhostTrans
                                Else
                                    If NormalTrans >= 21 Then
                                        NormalTrans = NormalTrans - 20
                                    End If
                                    setTranslucentAll NormalTrans
                                End If
                            
                            End Select
                            
                            ShiftPressed = 0
                            CtrlPressed = 0
                            AltPressed = 0
                            WinPressed = 0

                            Set tmpCB = FrmkeyPad.cmdEX(i)
                            KeyGot = True
                          
                            Exit For
                    End If
                Next
                
            End If
            
            'ghostbutton
            If KeyGot = False And (inPadType = 4 Or inPadType = 0) Then
                For i = 0 To frmGhostButton.cmdEX.Count - 1
                    If inX >= (frmGhostButton.cmdEX(i).Left) And _
                        inX <= (frmGhostButton.cmdEX(i).Left + frmGhostButton.cmdEX(i).Width) And _
                        inY >= (frmGhostButton.cmdEX(i).Top) And _
                        inY <= (frmGhostButton.cmdEX(i).Top + frmGhostButton.cmdEX(i).Height) Then
            
                                If i = 0 Then
                                       
                                       GhostMode = Not GhostMode
                                       toGhost GhostMode
                                       
                                End If

            
                                ShiftPressed = 0
                                CtrlPressed = 0
                                AltPressed = 0
                                WinPressed = 0
            
                            Set tmpCB = frmGhostButton.cmdEX(i)
                            KeyGot = True
                          
                            Exit For
                    End If
                Next
                
            End If
            
            If GhostMode = True Then
                Exit Sub
            End If
         
           
            If KeyGot = False And (inPadType = 1 Or inPadType = 0) Then
                For i = 1 To frmNumPad.cmdKey.Count
                    If inX >= (frmNumPad.cmdKey(i).Left) And _
                        inX <= (frmNumPad.cmdKey(i).Left + frmNumPad.cmdKey(i).Width) And _
                        inY >= (frmNumPad.cmdKey(i).Top) And _
                        inY <= (frmNumPad.cmdKey(i).Top + frmNumPad.cmdKey(i).Height) Then

                                frmNumPad.cmdKey(i).BackColor = &HC0C0C0
                                KPsendKeys frmNumPad.cmdKey(i).Tag

                                ShiftPressed = 0
                                CtrlPressed = 0
                                AltPressed = 0
                                'WinPressed = 0
                                
                            
                            Set tmpCB = frmNumPad.cmdKey(i)
                            KeyGot = True
                            Exit For
                    End If
                Next
            End If
            
            'if sympad is in use
            If KeyGot = False And SymMode = True And (inPadType = 3 Or inPadType = 0) Then
                For i = 0 To frmSymPad.cmdKey.Count - 1
                    If inX >= (frmSymPad.cmdKey(i).Left) And _
                        inX <= (frmSymPad.cmdKey(i).Left + frmSymPad.cmdKey(i).Width) And _
                        inY >= (frmSymPad.cmdKey(i).Top) And _
                        inY <= (frmSymPad.cmdKey(i).Top + frmSymPad.cmdKey(i).Height) Then
                        
                        frmSymPad.cmdKey(i).BackColor = &HC0C0C0
                        
                            If i = 9 Then
                                AltPressed = 1 - AltPressed
                                If AltPressed = 1 Then
                                    RegisterButton frmSymPad.cmdKey(9), keyFGDPressedcolor
                                Else
                                    RegisterButton frmSymPad.cmdKey(9), keyFGDcolor
                                End If
                            ElseIf i = 10 Then
                                CtrlPressed = 1 - CtrlPressed
                                If CtrlPressed = 1 Then
                                    RegisterButton frmSymPad.cmdKey(10), keyFGDPressedcolor
                                Else
                                    RegisterButton frmSymPad.cmdKey(10), keyFGDcolor
                                End If
                                
                            ElseIf i = 15 Then
                                ShiftPressed = 1 - ShiftPressed
                                If ShiftPressed = 1 Then
                                    RegisterButton frmSymPad.cmdKey(15), keyFGDPressedcolor
                                Else
                                    RegisterButton frmSymPad.cmdKey(15), keyFGDcolor
                                End If
                            ElseIf i = 16 Then
                            'print screen--can't call by sendkeys
                                keybd_event &H2C, 0, 0, 1
                                keybd_event &H2C, vbNull, KEYEVENTF_KEYUP, 1
                            Else
                                KPsendKeys frmSymPad.cmdKey(i).Tag

                            End If

                            ShiftPressed = 0
                            CtrlPressed = 0
                            AltPressed = 0
                            
                            Set tmpCB = frmSymPad.cmdKey(i)
                            KeyGot = True
                            Exit For
                            
                    End If
                Next
          
            End If
            
            
            
            'KeyPad
            If KeyGot = False And keyPadHid = False And (inPadType = 2 Or inPadType = 0) Then
                For i = 0 To FrmkeyPad.cmdKey.Count - 1
                    'Debug.Print FrmkeyPad.cmdKey(i).Caption & " " & inLbl(index, i)
                    If inLbl(Index, i) = True Then
                        
                        If inX >= (FrmkeyPad.cmdKey(i).Left) And _
                            inX <= (FrmkeyPad.cmdKey(i).Left + FrmkeyPad.cmdKey(i).Width) And _
                            inY >= (FrmkeyPad.cmdKey(i).Top) And _
                            inY <= (FrmkeyPad.cmdKey(i).Top + FrmkeyPad.cmdKey(i).Height) Then
                            
                            FrmkeyPad.cmdKey(i).BackColor = &HC0C0C0
                            
                            
                            Select Case i
                            Case 43
                            'alt
                                AltPressed = 1 - AltPressed
                                Debug.Print "alt; " & AltPressed
                                If AltPressed = 1 Then
                                    'RegisterButton FrmkeyPad.cmdKey(39), keyfgdpressedcolor
                                    RegisterButton FrmkeyPad.cmdKey(43), keyFGDPressedcolor
                                Else
                                    'RegisterButton FrmkeyPad.cmdKey(39), keyfgdcolor
                                    RegisterButton FrmkeyPad.cmdKey(43), keyFGDcolor
                                End If
                            Case 39
                                'show desktop
                                'WinPressed = 1 - WinPressed
                                keybd_event &H5B, vbNull, &H0, vbNull
                                keybd_event &H44, vbNull, &H0, vbNull
                                keybd_event &H5B, vbNull, KEYEVENTF_KEYUP, vbNull
                                keybd_event &H44, vbNull, KEYEVENTF_KEYUP, vbNull
                                                   
                                'If WinPressed = 1 Then
                                '    RegisterButton FrmkeyPad.cmdKey(39), keyfgdpressedcolor
                                'Else
                                '    WinPressed = 0
                                '    RegisterButton FrmkeyPad.cmdKey(39), keyfgdcolor
                                'End If
                            Case 40
                            'ctrl
                                CtrlPressed = 1 - CtrlPressed
                                Debug.Print "ctrl: " & CtrlPressed
                                If CtrlPressed = 1 Then
                                    RegisterButton FrmkeyPad.cmdKey(40), keyFGDPressedcolor

                                Else
                                    RegisterButton FrmkeyPad.cmdKey(40), keyFGDcolor

                                End If
                                
                            Case 32, 41
                            'shift
                                ShiftPressed = 1 - ShiftPressed
                                Debug.Print "shift: " & ShiftPressed
                                If ShiftPressed = 1 Then
                                    RegisterButton FrmkeyPad.cmdKey(32), keyFGDPressedcolor
                                    RegisterButton FrmkeyPad.cmdKey(41), keyFGDPressedcolor
                                Else
                                    RegisterButton FrmkeyPad.cmdKey(32), keyFGDcolor
                                    RegisterButton FrmkeyPad.cmdKey(41), keyFGDcolor
                                End If
                            Case 45
                            'capslock
                                CapsPressed = 1 - CapsPressed
                                If CapsPressed = 1 Then
                                    keybd_event &H14, vbNull, &H0, 1
                                    keybd_event &H14, vbNull, KEYEVENTF_KEYUP, 1
                                    RegisterButton FrmkeyPad.cmdKey(45), keyFGDPressedcolor
                                Else
                                    keybd_event &H14, vbNull, &H0, 1
                                    keybd_event &H14, vbNull, KEYEVENTF_KEYUP, 1
                                    RegisterButton FrmkeyPad.cmdKey(45), keyFGDcolor
                                End If
                            Case 42
                            'print screen--can't call by sendkeys
                                keybd_event &H2C, 0, 0, 1
                                keybd_event &H2C, vbNull, KEYEVENTF_KEYUP, 1
                            Case 48
                             'show explorer
                                keybd_event &H5B, vbNull, &H0, vbNull
                                keybd_event &H45, vbNull, &H0, vbNull
                                keybd_event &H5B, vbNull, KEYEVENTF_KEYUP, vbNull
                                keybd_event &H45, vbNull, KEYEVENTF_KEYUP, vbNull
                            Case Else
                                KPsendKeys FrmkeyPad.cmdKey(i).Tag

                                ShiftPressed = 0
                                CtrlPressed = 0
                                AltPressed = 0
                                'WinPressed = 0
                                
                            End Select
                            
                            
                            Set tmpCB = FrmkeyPad.cmdKey(i)
                            KeyGot = True
                            Exit For
                            
                        End If
                    End If
                Next
            End If
            
           
        '*********************Key Detection Code Ends*********************************
        
          '*********************Special Keys Code***************************************
            
         'Alt, Ctrl and shift pressing; processed here to allow for combo keys
         If AltPressed = 1 Then
             keybd_event 18, vbNull, &H0, vbNull
         Else
            keybd_event 18, vbNull, KEYEVENTF_KEYUP, vbNull
            RegisterButton FrmkeyPad.cmdKey(43), keyFGDcolor
            RegisterButton frmSymPad.cmdKey(10), keyFGDcolor
         End If
       
         If CtrlPressed = 1 Then
             keybd_event 17, vbNull, &H0, vbNull
         Else
             keybd_event 17, vbNull, KEYEVENTF_KEYUP, vbNull
             RegisterButton FrmkeyPad.cmdKey(40), keyFGDcolor
             RegisterButton frmSymPad.cmdKey(9), keyFGDcolor
         End If
         
         If ShiftPressed = 1 Then
             keybd_event 16, vbNull, &H0, vbNull
             ExtShiftPressed = 0
             loadKeys True
         Else
             keybd_event 16, vbNull, KEYEVENTF_KEYUP, vbNull
             RegisterButton FrmkeyPad.cmdKey(32), keyFGDcolor
             RegisterButton FrmkeyPad.cmdKey(41), keyFGDcolor
             RegisterButton frmSymPad.cmdKey(15), keyFGDcolor
             loadKeys False
         End If
         
         'If WinPressed = 1 Then
         '    keybd_event &H5B, vbNull, &H0, vbNull
         '    keybd_event &H44, vbNull, &H0, vbNull
         '    keybd_event &H5B, vbNull, KEYEVENTF_KEYUP, vbNull
         '    keybd_event &H44, vbNull, KEYEVENTF_KEYUP, vbNull
         '    WinPressed = 0
         'ElseIf WinPressed = 0 Then
         '    keybd_event &H5B, vbNull, KEYEVENTF_KEYUP, vbNull
         '    RegisterButton FrmkeyPad.cmdKey(39), keyfgdcolor
             
         'End If
        

        
        '*********************Special Keys Code Ends**********************************
        
        

        If KeyGot = True Then
            'Pause 0.001
            tmpCB.BackColor = keyBGDcolor
            'frmNumPad.Timer2.Enabled = True
        End If

        'restoreBGDcolor
        'frmNumPad.Timer2.Enabled = True


End Sub

Public Sub clearTrans()
                TimeSincePress = 0
                If AutoHide = True Then
                    setTranslucentAll NormalTrans
                    Pause 0.2
                    AutoHide = False
                End If
End Sub

Public Sub loadKeys(Optional inShift As Boolean = False)
Dim i As Integer

If inShift = False Then
    frmNumPad.cmdKey(1).Caption = "`"
    frmNumPad.cmdKey(2).Caption = "1"
    frmNumPad.cmdKey(3).Caption = "2"
    frmNumPad.cmdKey(4).Caption = "3"
    frmNumPad.cmdKey(5).Caption = "4"
    frmNumPad.cmdKey(6).Caption = "5"
    frmNumPad.cmdKey(7).Caption = "6"
    frmNumPad.cmdKey(8).Caption = "7"
    frmNumPad.cmdKey(9).Caption = "8"
    frmNumPad.cmdKey(10).Caption = "9"
    frmNumPad.cmdKey(11).Caption = "0"
    frmNumPad.cmdKey(12).Caption = "-"
    frmNumPad.cmdKey(13).Caption = "="
    frmNumPad.cmdKey(14).Caption = "/"
    frmNumPad.cmdKey(15).Caption = "*"
    frmNumPad.cmdKey(16).Caption = "Del"
    
    frmSymPad.cmdKey(0).Caption = "["
    frmSymPad.cmdKey(1).Caption = "]"
    frmSymPad.cmdKey(2).Caption = "\"
    frmSymPad.cmdKey(3).Caption = ";"
    frmSymPad.cmdKey(4).Caption = "'"
    frmSymPad.cmdKey(5).Caption = ","
    frmSymPad.cmdKey(6).Caption = "."
    frmSymPad.cmdKey(7).Caption = "/"
    
    FrmkeyPad.cmdKey(10).Caption = "["
    FrmkeyPad.cmdKey(11).Caption = "]"
    FrmkeyPad.cmdKey(12).Caption = "\"
    FrmkeyPad.cmdKey(38).Caption = ";"
    FrmkeyPad.cmdKey(37).Caption = "'"
    FrmkeyPad.cmdKey(36).Caption = ","
    FrmkeyPad.cmdKey(35).Caption = "."
    FrmkeyPad.cmdKey(30).Caption = "/"
    
Else
                frmNumPad.cmdKey(1).Caption = "~"
                frmNumPad.cmdKey(2).Caption = "!"
                frmNumPad.cmdKey(3).Caption = "@"
                frmNumPad.cmdKey(4).Caption = "#"
                frmNumPad.cmdKey(5).Caption = "$"
                frmNumPad.cmdKey(6).Caption = "%"
                frmNumPad.cmdKey(7).Caption = "^"
                frmNumPad.cmdKey(8).Caption = "&"
                frmNumPad.cmdKey(9).Caption = "*"
                frmNumPad.cmdKey(10).Caption = "("
                frmNumPad.cmdKey(11).Caption = ")"
                frmNumPad.cmdKey(12).Caption = "_"
                frmNumPad.cmdKey(13).Caption = "+"
                frmNumPad.cmdKey(14).Caption = "?"
                

                frmSymPad.cmdKey(0).Caption = "{"
                frmSymPad.cmdKey(1).Caption = "}"
                frmSymPad.cmdKey(2).Caption = "|"
                frmSymPad.cmdKey(3).Caption = ":"
                frmSymPad.cmdKey(4).Caption = Chr(34)
                frmSymPad.cmdKey(5).Caption = "<"
                frmSymPad.cmdKey(6).Caption = ">"
                frmSymPad.cmdKey(7).Caption = "?"
                
                FrmkeyPad.cmdKey(10).Caption = "{"
                FrmkeyPad.cmdKey(11).Caption = "}"
                FrmkeyPad.cmdKey(12).Caption = "|"
                FrmkeyPad.cmdKey(38).Caption = ":"
                FrmkeyPad.cmdKey(37).Caption = Chr(34)
                FrmkeyPad.cmdKey(36).Caption = "<"
                FrmkeyPad.cmdKey(35).Caption = ">"
                FrmkeyPad.cmdKey(30).Caption = "?"


End If
    
    
    
End Sub

Public Sub showKeyPad(Optional inShow As Boolean = True)
'KeyPad or SymPad

    If inShow Then
        If SymMode = True Then

            FrmkeyPad.Hide
            frmGhostButton.Hide
            frmSymPad.Show
        Else
            frmSymPad.Hide
            FrmkeyPad.Show
            frmGhostButton.Show
            frmGhostButton.ZOrder 0

        End If
    Else

            FrmkeyPad.Hide
            frmSymPad.Hide
            frmGhostButton.Hide
    End If

End Sub
Public Sub hidePads(Optional inHide As Boolean = True)
'minimize

    If inHide Then
            frmNumPad.cmdEX(1).Height = frmNumPad.cmdEX(1).Height / 2
            frmNumPad.Width = frmNumPad.cmdEX(0).Width + 80 '* Screen.Width / (Screen.TwipsPerPixelX * 1280)
            frmNumPad.Height = 700 '* Screen.Height / (Screen.TwipsPerPixelY * 1024)
            showKeyPad False
            AllHid = True
    
    Else
            frmNumPad.Width = frmNumPad.cmdEX(0).Width * 2 + frmNumPad.cmdKey(1).Width * (frmNumPad.cmdKey.Count)
            frmNumPad.cmdEX(1).Height = frmNumPad.cmdKey(1).Height
            frmNumPad.Height = 960 '* Screen.Height / (Screen.TwipsPerPixelY * 1024)
            showKeyPad True
            AllHid = False
   
    End If


End Sub
Public Sub ReadList(ByVal File_Name As String)
Dim fnum As Integer, ALine As String, tmpStr As String

On Error GoTo errHandler

fnum = FreeFile
Open File_Name For Input As fnum


Do While Not EOF(fnum)
    Line Input #fnum, ALine
    
    If (Left(ALine, 1) = "'" Or Left(ALine, 1) = "*" Or Left(ALine, 2) = "//") Then
        commentText = commentText & ALine & vbNewLine
    Else
        tmpStr = popfield(ALine, "=")
        
        Select Case LCase(tmpStr)
            
            'colors and transparency
            Case "keybgdcolor"
                keyBGDcolor = ALine
            
            Case "keyfgdcolor"
                keyFGDcolor = ALine
            
            Case "keyfgdpressedcolor"
                keyFGDPressedcolor = ALine
            
            Case "normaltrans"
                NormalTrans = ALine
            
            Case "ghosttrans"
                GhostTrans = ALine
            
            Case "autotrans"
                AutoTrans = ALine
            
            'SymPad or KeyPad
            Case "symmode"
                SymMode = ALine
            
            'Ghost mode and hiding
            Case "autohidetime"
                AutoHideTime = ALine
                
            Case "autohidemode"
                AutoHideMode = ALine
                
            Case "keypadrownum"
                lblPadRowNum = ALine
            
            Case "keypadcolnum"
                lblPadColNum = ALine
        
        End Select
        
    End If

Loop

Close fnum

errHandler:

Exit Sub
End Sub

Public Sub WriteList(ByVal File_Name As String)
Dim Outstr As String

        
Outstr = commentText & vbNewLine & _
            "keybgdcolor=" & keyBGDcolor & vbNewLine & _
            "keyfgdcolor=" & keyFGDcolor & vbNewLine & _
            "keyfgdpressedcolor=" & keyFGDPressedcolor & vbNewLine & _
            "normaltrans=" & NormalTrans & vbNewLine & _
            "ghosttrans=" & GhostTrans & vbNewLine & _
            "autotrans=" & AutoTrans & vbNewLine & _
            "symmode=" & SymMode & vbNewLine & _
            "autohidetime=" & AutoHideTime & vbNewLine & _
            "autohidemode=" & AutoHideMode & vbNewLine & _
            "keypadrownum=" & lblPadRowNum & vbNewLine & _
            "keypadcolnum=" & lblPadColNum & vbNewLine

WriteFile File_Name, Outstr

End Sub

Public Sub toGhost(Optional inGhost As Boolean = False, Optional Opacity As Integer = -1)

    If Opacity = -1 Then
        Opacity = GhostTrans
    End If

    If inGhost = True Then
        Call SetWindowLong(FrmkeyPad.hwnd, GWL_EXSTYLE, _
                            GetWindowLong(FrmkeyPad.hwnd, GWL_EXSTYLE) _
                            Or WS_EX_TRANSPARENT)
        Call SetWindowLong(frmNumPad.hwnd, GWL_EXSTYLE, _
                            GetWindowLong(frmNumPad.hwnd, GWL_EXSTYLE) _
                            Or WS_EX_TRANSPARENT)
                                                
        'reposition ghost button
        reposGhostKey
        
        'set translucent for all
        setTranslucentAll Opacity, , True
        SetTranslucent frmGhostButton.hwnd, RGB(0, 0, 255), NormalTrans, LWA_ALPHA

                                               
                                               Else
          
          Call SetWindowLong(FrmkeyPad.hwnd, GWL_EXSTYLE, _
                             GetWindowLong(FrmkeyPad.hwnd, GWL_EXSTYLE) _
                             And Not WS_EX_TRANSPARENT)
          Call SetWindowLong(frmNumPad.hwnd, GWL_EXSTYLE, _
                             GetWindowLong(frmNumPad.hwnd, GWL_EXSTYLE) _
                             And Not WS_EX_TRANSPARENT)
          
          SetTranslucent frmGhostButton.hwnd, RGB(0, 0, 255), 1, LWA_ALPHA
          setTranslucentAll NormalTrans

    End If
    
End Sub

Public Sub changeKBRes(inW As Integer, inH As Integer)
Dim i As Integer, xScale As Single, yScale As Single

    xScale = inW / oldPixelWidth
    yScale = inH / oldPixelHeight
    
        For i = 1 To frmNumPad.cmdKey.Count
                frmNumPad.cmdKey(i).Left = frmNumPad.cmdKey(i).Left * xScale
                frmNumPad.cmdKey(i).Top = frmNumPad.cmdKey(i).Top * yScale
                frmNumPad.cmdKey(i).Width = frmNumPad.cmdKey(i).Width * xScale
                frmNumPad.cmdKey(i).Height = frmNumPad.cmdKey(i).Height * yScale
        Next
        For i = 0 To frmSymPad.cmdKey.Count - 1
                frmSymPad.cmdKey(i).Left = frmSymPad.cmdKey(i).Left * xScale
                frmSymPad.cmdKey(i).Top = frmSymPad.cmdKey(i).Top * yScale
                frmSymPad.cmdKey(i).Width = frmSymPad.cmdKey(i).Width * xScale
                frmSymPad.cmdKey(i).Height = frmSymPad.cmdKey(i).Height * yScale
        Next
            
        For i = 0 To FrmkeyPad.cmdKey.Count - 1
                FrmkeyPad.cmdKey(i).Left = FrmkeyPad.cmdKey(i).Left * xScale
                FrmkeyPad.cmdKey(i).Top = FrmkeyPad.cmdKey(i).Top * yScale
                FrmkeyPad.cmdKey(i).Width = FrmkeyPad.cmdKey(i).Width * xScale
                FrmkeyPad.cmdKey(i).Height = FrmkeyPad.cmdKey(i).Height * yScale
        Next
        
        For i = 0 To frmNumPad.cmdEX.Count - 1
                frmNumPad.cmdEX(i).Left = frmNumPad.cmdEX(i).Left * xScale
                frmNumPad.cmdEX(i).Top = frmNumPad.cmdEX(i).Top * yScale
                frmNumPad.cmdEX(i).Width = frmNumPad.cmdEX(i).Width * xScale
                frmNumPad.cmdEX(i).Height = frmNumPad.cmdEX(i).Height * yScale
        Next
            
        For i = 0 To FrmkeyPad.cmdEX.Count - 1
                FrmkeyPad.cmdEX(i).Left = FrmkeyPad.cmdEX(i).Left * xScale
                FrmkeyPad.cmdEX(i).Top = FrmkeyPad.cmdEX(i).Top * yScale
                FrmkeyPad.cmdEX(i).Width = FrmkeyPad.cmdEX(i).Width * xScale
                FrmkeyPad.cmdEX(i).Height = FrmkeyPad.cmdEX(i).Height * yScale
        Next
        
        For i = 0 To frmGhostButton.cmdEX.Count - 1
                FrmkeyPad.cmdEX(i).Left = FrmkeyPad.cmdEX(i).Left * xScale
                FrmkeyPad.cmdEX(i).Top = FrmkeyPad.cmdEX(i).Top * yScale
                FrmkeyPad.cmdEX(i).Width = FrmkeyPad.cmdEX(i).Width * xScale
                FrmkeyPad.cmdEX(i).Height = FrmkeyPad.cmdEX(i).Height * yScale
        Next
    
        frmNumPad.Width = frmNumPad.Width * xScale
        frmNumPad.Height = frmNumPad.Height * yScale
        frmNumPad.Left = frmNumPad.Left * xScale
        frmNumPad.Top = frmNumPad.Top * yScale
        
        FrmkeyPad.Width = FrmkeyPad.Width * xScale
        FrmkeyPad.Height = FrmkeyPad.Height * yScale
        FrmkeyPad.Left = FrmkeyPad.Left * xScale
        FrmkeyPad.Top = FrmkeyPad.Top * yScale
        
        frmSymPad.Width = frmSymPad.Width * xScale
        frmSymPad.Height = frmSymPad.Height * yScale
        frmSymPad.Left = frmSymPad.Left * xScale
        frmSymPad.Top = frmSymPad.Top * yScale

        frmGhostButton.Width = frmGhostButton.Width * xScale
        frmGhostButton.Height = frmGhostButton.Height * yScale
        frmGhostButton.Left = frmGhostButton.Left * xScale
        frmGhostButton.Top = frmGhostButton.Top * yScale
        
        frmNumPad.lblPad(0).Width = frmNumPad.lblPad(0).Width * xScale
        frmNumPad.lblPad(0).Height = frmNumPad.lblPad(0).Height * yScale
        frmNumPad.lblPad(0).Left = frmNumPad.lblPad(0).Left * xScale
        frmNumPad.lblPad(0).Top = frmNumPad.lblPad(0).Top * yScale
        
        FrmkeyPad.lblPad(0).Width = FrmkeyPad.lblPad(0).Width * xScale
        FrmkeyPad.lblPad(0).Height = FrmkeyPad.lblPad(0).Height * yScale
        FrmkeyPad.lblPad(0).Left = FrmkeyPad.lblPad(0).Left * xScale
        FrmkeyPad.lblPad(0).Top = FrmkeyPad.lblPad(0).Top * yScale
        
        frmSymPad.lblPad(0).Width = frmSymPad.lblPad(0).Width * xScale
        frmSymPad.lblPad(0).Height = frmSymPad.lblPad(0).Height * yScale
        frmSymPad.lblPad(0).Left = frmSymPad.lblPad(0).Left * xScale
        frmSymPad.lblPad(0).Top = frmSymPad.lblPad(0).Top * yScale

        frmGhostButton.lblPad(0).Width = frmGhostButton.lblPad(0).Width * xScale
        frmGhostButton.lblPad(0).Height = frmGhostButton.lblPad(0).Height * yScale
        frmGhostButton.lblPad(0).Left = frmGhostButton.lblPad(0).Left * xScale
        frmGhostButton.lblPad(0).Top = frmGhostButton.lblPad(0).Top * yScale
        
    
    oldPixelWidth = Screen.Width / Screen.TwipsPerPixelX
    oldPixelHeight = Screen.Height / Screen.TwipsPerPixelY
    
End Sub

Public Sub checkVars()
       'set default color and translucent values if necessary; in development
       If keyBGDcolor = 0 And keyFGDcolor = 0 Then
        keyFGDcolor = vbWhite
       End If
       If keyBGDcolor = 0 And keyFGDPressedcolor = 0 Then
        keyFGDPressedcolor = vbRed
       End If
       If NormalTrans <= 0 Or NormalTrans > 255 Then
        NormalTrans = 100
       End If
       If GhostTrans <= 0 Or GhostTrans > 255 Then
        GhostTrans = 30
       End If
       If AutoTrans <= 0 Or AutoTrans > 255 Then
        AutoTrans = 1
       End If
       If lblPadRowNum <= 0 Then
        lblPadRowNum = 4
       End If
       If lblPadColNum <= 0 Then
        lblPadColNum = 2
       End If
End Sub


Public Sub registerInLbl()
Dim i As Integer, k As Integer
Dim inX1 As Integer, inY1  As Integer, inX2 As Integer, inY2 As Integer
Dim cX1 As Integer, cY1  As Integer, cX2 As Integer, cY2 As Integer

    For k = 0 To FrmkeyPad.lblPad.Count - 1
        For i = 0 To FrmkeyPad.cmdKey.Count - 1
        
            inX1 = FrmkeyPad.lblPad(k).Left
            inY1 = FrmkeyPad.lblPad(k).Top
            inX2 = FrmkeyPad.lblPad(k).Left + FrmkeyPad.lblPad(k).Width
            inY2 = FrmkeyPad.lblPad(k).Top + FrmkeyPad.lblPad(k).Height
            
            cX1 = FrmkeyPad.cmdKey(i).Left
            cY1 = FrmkeyPad.cmdKey(i).Top
            cX2 = FrmkeyPad.cmdKey(i).Left + FrmkeyPad.cmdKey(i).Width
            cY2 = FrmkeyPad.cmdKey(i).Top + FrmkeyPad.cmdKey(i).Height
            
            If ((inX1 <= cX1 And inX2 >= cX1) Or (inX1 <= cX2 And inX2 >= cX2)) And _
               ((inY1 <= cY1 And inY2 >= cY1) Or (inY1 <= cY2 And inY2 >= cY2)) Then
                     
               inLbl(k, i) = True
                
            End If
            
        Next
    Next

End Sub
