Attribute VB_Name = "ScreenModule"
'modified from script from online tutorial

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type RECT2
    Left As Long
    Top As Long
    Width As Long
    Height As Long
End Type

Public Declare Function SystemParametersInfo Lib "user32" _
    Alias "SystemParametersInfoA" (ByVal uAction As Long, _
    ByVal uParam As Long, ByRef lpvParam As RECT, ByVal _
    fuWinIni As Long) As Long
Public Const SPI_GETWORKAREA = 48

Public Function GetScreen() As RECT2
Dim wa_info As RECT

    If SystemParametersInfo(SPI_GETWORKAREA, _
        0, wa_info, 0) <> 0 _
    Then
        ' We got the work area bounds.
        ' Center the form in the work area.
        GetScreen.Width = Screen.TwipsPerPixelX * wa_info.Right
        GetScreen.Height = Screen.TwipsPerPixelY * wa_info.Bottom
        GetScreen.Left = Screen.TwipsPerPixelX * wa_info.Left
        GetScreen.Top = Screen.TwipsPerPixelY * wa_info.Top
    Else
        ' We did not get the work area bounds.
        ' Center the form on the whole screen.
        GetScreen.Width = Screen.Width
        GetScreen.Height = Screen.Height
        GetScreen.Top = 0
        GetScreen.Left = 0
    End If

End Function

